"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeRefRenderer = void 0;
exports.TypeRefName = TypeRefName;
const react_1 = __importDefault(require("react"));
const api_reference_models_api_node_renderer_1 = require("@teambit/api-reference.models.api-node-renderer");
const semantics_entities_semantic_schema_1 = require("@teambit/semantics.entities.semantic-schema");
const api_reference_renderers_api_node_details_1 = require("@teambit/api-reference.renderers.api-node-details");
const api_reference_utils_copy_schema_node_1 = require("@teambit/api-reference.utils.copy-schema-node");
const classnames_1 = __importDefault(require("classnames"));
const api_reference_hooks_use_api_ref_url_1 = require("@teambit/api-reference.hooks.use-api-ref-url");
const component_modules_component_url_1 = require("@teambit/component.modules.component-url");
const base_react_navigation_link_1 = require("@teambit/base-react.navigation.link");
const type_ref_renderer_module_scss_1 = __importDefault(require("./type-ref.renderer.module.scss"));
// @todo - this will be fixed as part of the @teambit/base-react.navigation.link upgrade to latest
const Link = base_react_navigation_link_1.Link;
exports.typeRefRenderer = {
    predicate: (node) => node.__schema === semantics_entities_semantic_schema_1.TypeRefSchema.name,
    Component: TypeRefComponent,
    nodeType: 'TypeRefs',
    icon: { name: 'TypeRef', url: 'https://static.bit.dev/api-reference/type.svg' },
    default: true,
};
function TypeRefComponent(props) {
    var _a, _b;
    const { apiNode: { api }, apiRefModel, depth, renderers, } = props;
    const typeRefNode = api;
    const TypeRefWrapper = ({ children }) => depth === 0 ? (react_1.default.createElement(api_reference_renderers_api_node_details_1.APINodeDetails, Object.assign({}, props, { apiNode: Object.assign(Object.assign({}, props.apiNode), { api: (0, api_reference_utils_copy_schema_node_1.copySchemaNode)(typeRefNode, { signature: typeRefNode.signature || typeRefNode.toString() }) }), options: { hideIndex: true } }), children)) : (react_1.default.createElement(react_1.default.Fragment, null, children));
    const exportedTypeFromSameComp = typeRefNode.isFromThisComponent()
        ? apiRefModel.getByName(typeRefNode, typeRefNode.internalFilePath)
        : undefined;
    const exportedTypeUrlFromSameComp = exportedTypeFromSameComp &&
        (0, api_reference_hooks_use_api_ref_url_1.useUpdatedUrlFromQuery)({
            selectedAPI: typeRefNode.isInternalReference()
                ? apiRefModel.internalAPIKey(typeRefNode, typeRefNode.internalFilePath)
                : exportedTypeFromSameComp.api.name,
        });
    const exportedTypeUrlFromAnotherComp = typeRefNode.componentId
        ? getExportedTypeUrlFromAnotherComp({
            componentId: typeRefNode.componentId,
            selectedAPI: typeRefNode.name,
        })
        : undefined;
    const packageUrl = typeRefNode.packageName ? `https://www.npmjs.com/package/${typeRefNode.packageName}` : undefined;
    const args = (_b = (_a = typeRefNode.typeArgs) === null || _a === void 0 ? void 0 : _a.map((typeArg, index, typeArgs) => {
        var _a, _b, _c, _d, _e;
        const typeArgRenderer = renderers.find((renderer) => renderer.predicate(typeArg));
        if (typeArgRenderer) {
            return (react_1.default.createElement(react_1.default.Fragment, { key: `type-arg-renderer-container-${typeArg.__schema}-${typeArg.toString()}-${index}` },
                react_1.default.createElement(typeArgRenderer.Component, Object.assign({ key: `type-arg-${typeArg.__schema}-${typeArg.toString()}-${index}` }, props, { className: type_ref_renderer_module_scss_1.default.typeArgNode, apiNode: Object.assign(Object.assign({}, props.apiNode), { api: typeArg, renderer: typeArgRenderer }), depth: ((_a = props.depth) !== null && _a !== void 0 ? _a : 0) + 1, metadata: { [typeArg.__schema]: { columnView: true } } })),
                ((_b = typeArgs === null || typeArgs === void 0 ? void 0 : typeArgs.length) !== null && _b !== void 0 ? _b : 0) > 1 && index !== ((_c = typeArgs === null || typeArgs === void 0 ? void 0 : typeArgs.length) !== null && _c !== void 0 ? _c : 0) - 1 ? ', ' : null));
        }
        return (react_1.default.createElement(react_1.default.Fragment, { key: `type-arg-container-${typeArg.__schema}-${typeArg.toString()}-${index}` },
            typeArg.toString(),
            ((_d = typeArgs === null || typeArgs === void 0 ? void 0 : typeArgs.length) !== null && _d !== void 0 ? _d : 0) > 1 && index !== ((_e = typeArgs === null || typeArgs === void 0 ? void 0 : typeArgs.length) !== null && _e !== void 0 ? _e : 0) - 1 ? ', ' : null));
    })) !== null && _b !== void 0 ? _b : null;
    if (args) {
        return (react_1.default.createElement(TypeRefWrapper, null,
            react_1.default.createElement(react_1.default.Fragment, { key: `typeRef-with-args-container-${typeRefNode.name}` },
                react_1.default.createElement(TypeRefName, { key: `typeRef-with-args-${typeRefNode.name}`, name: typeRefNode.name, external: Boolean(exportedTypeUrlFromAnotherComp) || Boolean(packageUrl), url: exportedTypeUrlFromSameComp || exportedTypeUrlFromAnotherComp || packageUrl, exported: typeRefNode.isExported(), internal: typeRefNode.isInternalReference(), packageName: typeRefNode.packageName },
                    react_1.default.createElement("div", { key: `typeArgsContainer-${typeRefNode.name}`, className: type_ref_renderer_module_scss_1.default.typeArgs },
                        '<',
                        args.map((arg) => arg),
                        '>')))));
    }
    return (react_1.default.createElement(TypeRefWrapper, null,
        react_1.default.createElement(TypeRefName, { key: `typeRef-${typeRefNode.name}`, name: typeRefNode.name, external: Boolean(exportedTypeUrlFromAnotherComp) || Boolean(packageUrl), url: exportedTypeUrlFromSameComp || exportedTypeUrlFromAnotherComp || packageUrl, exported: typeRefNode.isExported(), internal: typeRefNode.isInternalReference(), packageName: typeRefNode.packageName })));
}
const LinkContext = react_1.default.createContext(false);
function TypeRefName({ name, url, external, children, internal, exported, packageName, }) {
    const className = (0, classnames_1.default)(api_reference_models_api_node_renderer_1.nodeStyles.node, {
        [type_ref_renderer_module_scss_1.default.internalType]: internal,
        [type_ref_renderer_module_scss_1.default.exportedType]: exported,
        [type_ref_renderer_module_scss_1.default.package]: !!packageName,
    });
    // Check if current component is nested within a Link.
    const withinLink = react_1.default.useContext(LinkContext);
    if (url && !withinLink) {
        return (react_1.default.createElement(LinkContext.Provider, { value: true },
            react_1.default.createElement(Link, { href: url, external: external, className: (0, classnames_1.default)(className, type_ref_renderer_module_scss_1.default.nodeLink) },
                name,
                external && react_1.default.createElement("div", { className: type_ref_renderer_module_scss_1.default.locationIcon },
                    react_1.default.createElement("img", { src: "https://static.bit.dev/design-system-assets/Icons/external-link.svg" })),
                children)));
    }
    return (react_1.default.createElement("div", { className: className },
        name,
        children));
}
function getExportedTypeUrlFromAnotherComp({ componentId, selectedAPI, }) {
    const componentUrl = component_modules_component_url_1.ComponentUrl.toUrl(componentId, { useLocationOrigin: false, includeVersion: true });
    const [componentIdUrl, versionQuery] = componentUrl.split('?');
    const exportedTypeUrl = `${componentIdUrl}/~api-reference?selectedAPI=${encodeURIComponent(selectedAPI)}${versionQuery ? `&${versionQuery}` : ''}`;
    return exportedTypeUrl;
}
//# sourceMappingURL=type-ref.renderer.js.map